<?php

namespace App\Code\Geometry;

class Rectangle extends Square
{
    private $myvar;

    public $b;

    public function __construct($a = null, $b = null)
    {
        $this->myvar = "foo";
        if ($b) {
            $this->b = $b;
        }
        parent::__construct($a);
    }

    public function printA()
    {
        echo "This is A: ".$this->a;
    }

    public function getPerimeter()
    {
        return $this->getA()*2 + $this->getB()*2;
    }

    public function getSquare()
    {
        return $this->getA()*$this->getB();
    }

    public function __get($name)
    {
        throw new \Exception("not defined");
    }

    public function __call($name, $arguments)
    {
        if (strtolower($name) == "whatsmyname" ) {
            echo self::class;
            echo "\n";
            return;
        }

        return parent::__call($name, $arguments); // TODO: Change the autogenerated stub
    }
}